<?php
class SimpleMailAdminBar
{
	public function __construct()
	{
		add_action('init', array($this, 'init'));
	}
	
	public function init()
	{
		global $sm_plugin;
		if($sm_plugin->settings->admin_bar)
		{
			add_action('admin_bar_menu', array($this, 'addItem'), 100);
			//add_action('wp_print_styles', array($this, 'style'));
		}
	}
	
	public function style()
	{
		wp_enqueue_style('sm_menu_css', plugins_url('ui/admin-bar-style.css', __FILE__));
	}
	
	public function addItem()
	{
		global $wp_admin_bar, $sm_plugin;

		if(!$sm_plugin->ready())
			$url = admin_url('options-general.php?page=simplemail_settings&nag=not-ready');
		else
			$url = admin_url('admin.php?page=simplemail');
		
		//$title = __('Email');
		$title = '<span class="ab-icon" style="background-image:url(\'' . $sm_plugin->url . '/ui/images/admin_bar.png' . '\');"></span>';
		if($sm_plugin->settings->notifications && $sm_plugin->ready())
		{
			$unseen = $sm_plugin->client->status->unseen;
			if($unseen)
			{
				//$title .= SMLibrary::format_email_notice($unseen);
				$title .= ' <span class="ab-label">' . number_format_i18n($unseen) . '</span>';
			}
		}
		//top level
		$wp_admin_bar->add_menu( array(
			'title' 	=> $title,
			'href' 		=> $url,
			'parent' 	=> false,
			'id'		=> 'simplemail'
		) );
	}
}
new SimpleMailAdminBar();
?>