<?php
class SimpleMailAjax
{
	public function __construct()
	{
		add_action('wp_ajax_simplemail_get_messages', array($this, 'getMessages'));
		add_action('wp_ajax_simplemail_delete_messages', array($this, 'deleteMessages'));
		add_action('wp_ajax_simplemail_move_messages', array($this, 'moveMessages'));
		add_action('wp_ajax_simplemail_flag_messages', array($this, 'flag'));
		
		add_action('wp_ajax_simplemail_create_list', array($this, 'createList'));
		add_action('wp_ajax_simplemail_delete_list', array($this, 'deleteList'));
		add_action('wp_ajax_simplemail_add_contact', array($this, 'addAddress'));
		add_action('wp_ajax_simplemail_delete_contact', array($this, 'deleteAddress'));
	}
	
	public function nopriv()
	{
		
	}
	
	public function createList()
	{
		global $sm_plugin, $current_user;
		get_currentuserinfo();
		
		$name = $_GET['list_name'];
		$public = (int) $_GET['list_public'];
		
		if($id = $sm_plugin->addresses->addList($current_user->ID, $name, $public, $exists))
		{
			$list = $sm_plugin->addresses->getListById($id);
			SM_UI::displayList(array_shift($list));
		}

		exit;
	}
	
	public function deleteList()
	{
		global $sm_plugin;
		$id = $_GET['list_id'];
		$addresses = isset($_GET['addresses']) ? $_GET['addresses'] : null;
		$destination = isset($_GET['destination']) ? $_GET['destination'] : null;
		
		if($addresses == 'move')
			$sm_plugin->addresses->moveAddresses($id, $destination);
		else
			$sm_plugin->addresses->deleteAddressesByList($id);
		
		$sm_plugin->addresses->deleteListById($id);
		
		exit;
	}
	
	public function addAddress()
	{
		$list_id 	= (int) $_GET['list_id'];
		$name 		= $_GET['contact_name'];
		$address 	= $_GET['contact_address'];
		$info 		= $_GET['contact_info'];
		
		if(!$address)
			exit;
			
		global $sm_plugin;
		
		$address_id = $sm_plugin->addresses->addAddress($list_id, $address, $name, $info);
		if($address_id === false)
			exit;
			
		$address = $sm_plugin->addresses->getAddressById($address_id);
		//print_r($address);exit;
		
		if($address)
			SM_UI::displayAddress(array_shift($address));
		
		exit;
	}
	
	public function deleteAddress()
	{
		global $sm_plugin;
		$address_id = (int) $_GET['address_id'];
		
		$sm_plugin->addresses->deleteAddressById($address_id);
		
		exit;
	}
	
	public function getMessages()
	{
		$page = (int) $_GET['email_page'];

		global $sm_plugin;
		if(!$sm_plugin || !$sm_plugin->client)
		{
			?>
			<tr><td colspan="5"><?php SM_UI::loginForm(); ?></td></tr>
			<?php
			exit;
		}
		if($_GET['query'] && $_GET['criteria'])
			$messages = $sm_plugin->client->search($_GET['query'], $_GET['criteria']);
		else
			$messages = $sm_plugin->client->messageList($page, $sm_plugin->settings->messages_per_page);
		
		SM_UI::drawTable($messages);
		exit;
	}
	
	public function deleteMessages()
	{
		$messages = $_GET['messages'];
		
		global $sm_plugin;
		$box = $sm_plugin->client->current_mailbox;
		
		if($sm_plugin->client->deleteMessages($messages))
			echo count($messages) . __(' Messages Deleted.');
		else
			_e('Could not delete messages');
				
		exit;
	}
	
	public function moveMessages()
	{
		global $sm_plugin;
		$messages = $_GET['messages'];
		$destination = $sm_plugin->client->slugToMailbox($_GET['destination']);
		
		if($sm_plugin->client->moveMessages($messages, $destination))
			echo count($messages) . __(' messages moved.');
		else
			_e('Could not move messages.');
		
		exit;
	}
	
	public function flag()
	{
		$messages = $_GET['messages'];
		$flag = $_GET['flag'];
		$set = (boolean) $_GET['set'];
		
		global $sm_plugin;
		if($sm_plugin->client->flagMessages($messages, $set, '\\' . $flag))
			echo 'success';
		else
			echo 'fail';
		exit;
	}
}
new SimpleMailAjax();
?>