<?php
class SM_UI
{
	public static $tz;
	public static $format;
	
	/**
		Settings
		**/
	
	static function displaySettings($global = true)
	{
		global $sm_plugin, $user_config, $current_user;
		if(!function_exists('sm_settings_checkbox'))
		{
			function sm_settings_checkbox($setting)
			{
				global $user_config;
				$checked = (isset($user_config->$setting)) ? ' checked="checked"' : '';
			?>
			<input type="checkbox" name="user_config_<?php echo $setting; ?>" value="1"<?php echo $checked; ?>/>
			<?php
			}
		}
		
		$settings = get_option('simplemail_settings');
		$user_config = new stdClass();
		
		$values = $settings;
?>
	<tr>
		<th>Host</th>
		<td><input type="text" name="sm_host" value="<?php echo $values->host; ?>" /></td>
		<td class="setting_description"><span>The address of the mail server.
										Can be domain name or IP address. 
										If the mail server is using a non-standard port you must include the port number.<br />
										Ex. mail.domain.net:143</span></td>
	</tr>
		
	<tr>
		<th>Flags</th>
		<td>
			<table class="connection_flags fixed">
			<?php $toggle = false;		
			foreach($values->flags as $key => $isset) : $toggle = !$toggle; ?>
				<?php if($toggle) : ?><tr><?php endif; ?><td><input type="checkbox" name="sm_flags[]" value="<?php echo $key; ?>" <?php if($isset){ echo 'checked="checked"'; } ?> /><?php echo $key; ?></td><?php if(!$toggle) : ?></tr><?php endif; ?>
			<?php endforeach; ?>
			<?php if($toggle) : ?></tr><?php endif; ?>
			</table>
		</td>
		<td class="setting_description"><span>Flags tell the plugin how to connect to the mail server. You can find more information on how to properly set flags in the support forum.</span></td>
	</tr>
		
	<tr>
		<th>Force Login</th>
		<td><input type="checkbox" name="sm_force_login" value="1"<?php if($values->force_login) echo ' checked="checked"'; ?> /></td>
		<td class="setting_description"><span>When set, usernames and passwords will not be stored. Users will have to login everytime they 
										access their email. Notifications (see below) will only be displayed once a user has logged in.</span></td>
	</tr>
		
	<tr>
		<th>Username</th>
		<td><input type="text" name="sm_username" value="<?php echo $values->username; ?>" /></td>
		<td class="setting_description"><span>The username used to access your email. Typically the same as your email address.</span></td>
	</tr>
		
	<tr id="username_suffix" style="display:none;">
		<th>Username Suffix</th>
		<td><input type="text" name="sm_username_suffix" value="<?php echo $values->username_suffix; ?>" /></td>
		<td class="setting_description"><span>This setting can be used if every user is using the same domain for their email address.
										For example, if all of your users are using an @mydomain.com email address, set the suffix
										to @mydomain.com. When set, users only have to provide the username portion of their email address.</span></td>
	</tr>
		
	<tr>
		<th>Password</th>
		<td><input type="password" name="sm_password" value="<?php echo $values->password; ?>" /></td>
		<td class="setting_description"><span>The password corresponding to your username.</span></td>
	</tr>
		
	<tr>
		<th>Notifications</th>
		<td><input type="checkbox" name="sm_notifications" value="1"<?php if($values->notifications) echo ' checked="checked"'; ?> /></td>
		<td class="setting_description"><span>When enabled a number will appear next to the 'Email' menu indicating the number of unread messages in your inbox.</span></td>
	</tr>
		
	<tr>
		<th>Admin Bar</th>
		<td><input type="checkbox" name="sm_admin_bar" value="1"<?php if($values->admin_bar) echo ' checked="checked"'; ?> /></td>
		<td class="setting_description"><span>When enabled a 'Email' button will appear in the Wordpress admin bar. 
										If notifications are enabled it will also indicate the number of unread messages in your inbox.</span></td>
	</tr>
		
	<tr>
		<th>Menu Position</th>
		<td><input type="text" name="sm_menu_position" value="<?php echo $values->menu_position; ?>" style="width:35px;" /></td>
		<td class="setting_description"><span>A numeric value indicating the position of the 'Email' menu in the admin sidebar. Lower values will move the menu upward.
										Leave blank to use the default position. <strong>Warning:</strong> setting the position to a value equal to that of another
										menu will cause that menu not to be displayed.</span></td>
	</tr>
		
	<tr>
		<th>Messages per Page</th>
		<td><input type="text" name="sm_messages_per_page" value="<?php echo $values->messages_per_page; ?>" style="width:36px;" /></td>
		<td class="setting_description"><span>The number of messages to display when viewing a mail box.</span></td>
	</tr>
		
	<tr>
		<th>Signature</th>
		<td><textarea name="sm_signature" style="width:180px;height:26px;z-index:100;"><?php echo htmlentities($values->signature); ?></textarea></td>
		<td class="setting_description"><span>This text will be added to the end of each email you send.</span></td>
	</tr>
		
	<tr>
		<th>Permissions</th>
		<td>
		<?php $all_roles = SMLibrary::get_roles(); $set_roles = isset($_POST['permissions']) ? $_POST['permissions'] : SMLibrary::can_access_email(); ?>
		<select style="height:<?php echo 2 + 17 * count($all_roles); ?>px;" name="sm_permissions[]" multiple="multiple">
			<?php foreach($all_roles as $value => $display) : ?>
			<option value="<?php echo $value; ?>"<?php if(in_array($value, $set_roles)) echo ' selected="selected"'; ?>><?php echo $display; ?></option>
			<?php endforeach; ?>
		</select>
		</td>
		<td class="user_option"></td>
		<td class="setting_description"><span>Specify which roles can access email. Ctrl+click to select multiple roles.</span></td>
	</tr>
	<?php
	}
	
	
	static function formatFrom($from, $id)
	{
		$regex = '/<.*>/';
		$is_name = false;
		
		if(preg_match($regex, $from, $match))
		{
			$email = str_replace(array('<', '>'), '', $match[0]);

			$is_name = true;
			$from = preg_replace($regex, '', $from);
			return '<span class="from-name">' . self::formatSubject($from) . '<span class="from-email" id="from-' . $id . '">' . $email . '</span></span>';
		}
		
		return '<span id="from-' . $id . '">' . self::formatSubject($from) . '</span>';
	}
	
	static function formatSubject($subject)
	{
		if($subject == '')
			return __('(no subject)');
			
		$chars = 40;
		$append = '';
		if($chars < strlen($subject))
			$append = '&hellip;';
		$subject = substr($subject, 0, $chars - 1) . $append;
		return $subject;
	}
	
	static function formatDate($date, $full = false)
	{
		if(!self::$tz)
		{
			$zone = get_option('timezone_string');
			date_default_timezone_set($zone);
			self::$tz = $zone;
			self::$format = get_option('date_format');
		}
		$ts = strtotime($date);
		if($full)
			return date_i18n('l F, jS Y h:i:s A', $ts);
		
		$diff = time() - $ts;
		
		if($diff < 60)
			$short = $diff . __(' Seconds Ago');
		elseif($diff < (60 * 60)) //minutes
			$short = round($diff / 60.0) . __(' Minutes Ago');
		elseif($diff < (60 * 60 * 24)) //today
			$short = round($diff / 60.0 / 60.0) . __(' Hours Ago');
		elseif(date('j', $ts) == date('j', time() - (60*60*24)))
			$short = __('Yesterday');
		elseif($diff < (60 * 60 * 24 * 6))
			$short = date_i18n('l', $ts);
		else
			$short = date_i18n(self::$format, $ts);
			
		$full = date_i18n('l F, jS Y h:i:s A', $ts);

		return '<span class="email-date">' . $short . '<span>' . $full . '</span></span>';
	}
	
	static function drawTable($messages)
	{
		if(!is_array($messages) || count($messages) < 1) : ?>
		<tr><td colspan="5" style="text-align:center;"><em><?php _e('No Messages'); ?></em></td></tr>
		<?php else : ?>
		<?php foreach($messages as $msg) : ?>
		<tr<?php echo ($msg->seen) ? '' : ' class="unseen"'; ?>>
			<td class="email_check"><input type="checkbox" value="<?php echo $msg->uid; ?>" class="message_checkbox" name="message_checkbox[]" />
			<td><?php echo SM_UI::formatFrom($msg->from, $msg->uid); ?></td>
			<td><?php echo SM_UI::formatDate($msg->date); ?></td>
			<td><a href="<?php echo admin_url('admin.php') . '?page=' . $_GET['page'] . '&uid=' . $msg->uid; ?>&email_page=<?php echo isset($_GET['email_page']) ? $_GET['email_page'] : 1; ?>" title="<?php echo htmlentities($msg->subject); ?>" id="subject-<?php echo $msg->uid; ?>"><?php echo SM_UI::formatSubject($msg->subject); ?></a></td>
			<td><?php SM_UI::messageOptions($msg->uid, $msg->seen); ?></td>
		</tr>
		<?php endforeach; ?>
		<?php endif;
	}
	
	static function messageOptions($id, $read = false, $multiple = false)
	{					
		$options = array();
		if(!$multiple)
		{
			$options['reply'] = __('Reply');
			$options['forward'] = __('Forward');
		}
		$options['delete'] 	= __('Delete');
								
		if($read || $multiple)
			$options['mark_unread'] = __('Mark Unread');
		if(!$read || $multiple)
			$options['mark_read'] = __('Mark Read');
		
		?>
		<select class="message_options" id="message-<?php echo $id; ?>">
		<?php if($multiple) : ?>
			<option value=""><?php _e('With Selected...'); ?></option>
		<?php else : ?>
			<option value=""></option>
		<?php endif; ?>
		<?php foreach($options as $val => $display) : ?>
			<option value="<?php echo $val; ?>"><?php echo $display; ?></option>
		<?php endforeach; ?>
		</select>
		<?php
	}
	
	static function loginForm()
	{
?>
<div id="login_container">
<form method="post" action="">
	<div id="sm_login">
		<p>
			<label>Username<br />
			<input type="text" name="sm_username" id="sm_username" class="input" value="" size="20" tabindex="10" /></label>
		</p>
		<p>
			<label>Password<br />
			<input type="password" name="sm_password" id="sm_password" class="input" value="" size="20" tabindex="20" /></label>
		</p>
		<p class="submit">
			<input type="submit" name="sm_login_submit" class="button-primary" value="Log In" tabindex="100" />
		</p>
	</div>
</form>
</div>
<?php
	}
	
	static function formatComposeSubject($subject)
	{
		if(isset($_GET['reply']))
		{
			if(stripos($subject, 're:') !== 0)
				$subject = 'Re: ' . $subject;
		}
		elseif(isset($_GET['forward']))
		{
			if(stripos($subject, 'fwd:') !== 0)
				$subject = 'Fwd: ' . $subject;
		}
			
		return $subject;
	}
	
	static function formatComposeContent($content)
	{
		if(isset($_GET['reply']))
			$content = '---------------------------- ' . __('Original Message') . ' ----------------------------' . "\n" . $content;
		elseif(isset($_GET['forward']))
			$content = '---------------------------- ' . __('Original Message') . ' ----------------------------' . "\n" . $content;
			
		return htmlentities($content);
	}
	
	/**
		Addresses
		**/
	static function displayList($list, $public = false)
	{
		?>
		<table id="list-<?php echo $list->id; ?>" class="widefat fixed address_list">
			<thead>
			<tr>
				<th colspan="4" class="list_name"><?php echo $list->name; ?> <span> (<?php echo __('id: ') . $list->id; ?>)</span></th>
				<th style="text-align:right;">
					<?php self::working(); ?>
					<?php if($public) : _e('Public'); ?><input style="vertical-align:middle;" type="checkbox" value="<?php echo $list->id; ?>" class="public-checkbox" /><?php endif; ?>
				</th>
			</tr>
			<tr>
				<th style="width:24px;"><input type="checkbox" class="select-all" style="position:relative;left:-7px;" /></th>
				<th><?php _e('Address'); ?></th>
				<th><?php _e('Name'); ?></th>
				<th><?php _e('Additional Info'); ?></th>
				<th></th>
			</tr>
			</thead>
			<tbody>
			<?php if(!isset($list->addresses) || count($list->addresses) == 0) : ?>
			<tr class="no-addresses">
				<td colspan="5" style="text-align:center;"><em><?php _e('No Contacts'); ?></em></td>
			</tr>
			<?php else : ?>
			
			<?php foreach($list->addresses as $address) : ?>
				<?php self::displayAddress($address); ?>
			<?php endforeach; ?>
			
			<?php endif; ?>
			</tbody>
			<tfoot>
				<th></th>
				<th colspan="4" class="list_options">
					<a class="add_contact_link" id="ad-to-list-<?php echo $list->id; ?>"><?php _e('+Add Contact'); ?></a> 
					<a class="delete_list_link" id="delete-list-<?php echo $list->id; ?>"><?php _e('Delete List'); ?></a>
				</th>
			</tfoot>
		</table>
		<?php
	}
	
	public function displayAddress($address)
	{
		global $sm_plugin;
		$lists = $sm_plugin->addresses->getLists();
		?>
		<tr id="address-<?php echo $address->id; ?>">
			<td><input type="checkbox" class="select-address" value="<?php echo self::formatRecipient($address->address, $address->name); ?>" /></td>
			<td><?php echo htmlentities($address->address); ?></td>
			<td><?php echo $address->name; ?></td>
			<td><?php echo $address->info; ?></td>
			<td style="text-align:right;">
				<?php self::working(); ?>
				<?php if(count($lists->private) > 1) : ?>
				<select id="move-address">
					<option value=""><?php _e('Move To&hellip;'); ?></option>
				<?php foreach($lists->private as $list) : ?>
					<option value="<?php echo $list->id; ?>"><?php echo $list->name; ?></option>
				<?php endforeach; ?>
				</select>
				<?php endif; ?>
				<a class="delete-address" id="delete-address-<?php echo $address->id; ?>">Delete</a> 
			</td>
		</tr>
		<?php
	}
	
	public function formatRecipient($addr, $name)
	{
		return htmlentities("$addr <$name>");
	}
	
	static function working($id = '')
	{
		?>
		<span id="<?php echo $id; ?>" class="sm-working">&nbsp;</span>
		<?php
	}
	
	static function footer()
	{
		global $sm_plugin;
?>
<div id="sm_footer">
	<a href="<?php echo SimpleMailPlugin::HOME; ?>" target="_blank"><img src="<?php echo $sm_plugin->url . '/ui/images/sm2.png'; ?>" /></a><br />
	<a href="<?php echo SimpleMailPlugin::FORUM; ?>" target="_blank">Support and Feedback</a>
</div>
<?php
	}
}
?>