	var sm_selected_messages = new Array();
	
	var messageOptionInit = function($)
	{
		$('.message_options').change(function() {
			var id = String(this.id).replace('message-', '');
			var action = $(this).val();
			var messages = new Array();
			if(id == 'with-selected')
			{
				//multiple messages
				$('.message_checkbox:checked').each(function() {
					messages.push( $(this).val() );
				});
			}
			else
				messages.push(id);

			if(messages.length > 0)
			{
				//delegate
				switch(action)
				{
					case 'delete':
						deleteMessages($, messages);
					break;
					case 'mark_read':
						flagMessages($, messages, 1, 'Seen');
					break;
					case 'mark_unread':
						flagMessages($, messages, 0, 'Seen');
					break;
					case 'move':
						moveMessages($, messages);
					break;
					case 'reply':
						replyToMessage($, messages[0]);
					break;
					case 'forward':
						forwardMessage($, messages[0]);
					break;
				}
			}
			
			//$('.message_options option').attr('selected', '');
			$('.wrap option:selected').removeAttr('selected');
		});
		
		$('[name="move_email"]').click(function() {
			var dest = $('[name="destination"]').val();
			if(dest != '')
			{
				$.get(ajaxurl, {page: SimpleMail.box, messages: sm_selected_messages, destination: dest, action: 'simplemail_move_messages'}, function(result) {
					if(SimpleMail.single)
						window.location.replace(SimpleMail.returnURL + '&nag=message-moved');
					else
					{
						$('#sm_notice p strong').html(result);
						$('#sm_notice').show();
						fetchEmailList($);
						$('#move-cancel').click();
					}
				});
				
				sm_selected_messages = new Array();
			}
		});

		$('#move-cancel').click(function() {
			$(".sm-pop-cont").fadeOut();
			$(".sm-pop-bg").fadeOut();
		});
	}
	
	var replyToMessage = function($, message)
	{
		window.location.replace(SimpleMail.composeURL + '&reply=' + message + '&box=' + SimpleMail.box);
	}
	
	var forwardMessage = function($, message)
	{
		window.location.replace(SimpleMail.composeURL + '&forward=' + message + '&box=' + SimpleMail.box);
	}
	
	var deleteMessages = function($, messages)
	{
		var proceed = false;
		if(messages.length == 1)
		{
			if(typeof SimpleMail.subject == 'undefined')
			{
				var subject = $('#subject-' + messages[0]).html();
				var sender = $('#from-' + messages[0]).html();
			}
			else
			{
				var subject = SimpleMail.subject;
				var sender = SimpleMail.from;
			}

			if(confirm('Are you sure you want to delete this message?\n\nSubject: ' + subject + '\nFrom: ' + sender + '\n'))
				proceed = true;
		}
		else if(messages.length > 1 && confirm('Delete ' + messages.length + ' Messages?'))
			proceed = true;
			
		if(!proceed)
			return false;
			
		$.get(ajaxurl, {page: SimpleMail.box, messages: messages, action: 'simplemail_delete_messages'}, function(result) {
			if(SimpleMail.single)
				window.location.replace(SimpleMail.returnURL + '&nag=email-deleted');
			else
			{
				$('#sm_notice p strong').html(result);
				$('#sm_notice').show();
				fetchEmailList($);
			}
		});
	}
	
	var flagMessages = function($, messages, set, flag)
	{
		$.get(ajaxurl, {page: SimpleMail.box, messages: messages, flag: flag, set: set, action: 'simplemail_flag_messages'}, function(result) {
			fetchEmailList($);
		});
	}
	
	var moveMessages = function($, messages)
	{
		if(messages.length == 1)
		{
			if(typeof SimpleMail.subject == 'undefined')
			{
				var subject = $('#subject-' + messages[0]).html();
				var sender = $('#from-' + messages[0]).html();
			}
			else
			{
				var subject = SimpleMail.subject;
				var sender = SimpleMail.from;
			}
			
			var pre = 'Subject: ' + subject + '<br />' + 'From: ' + sender + '<br />';
		}
		else
			var pre = messages.length + ' messages selected.<br />';
			
		$('#move-info').html(pre);
		
		$(".sm-pop-cont").fadeIn();
		$(".sm-pop-bg").fadeIn();
		
		sm_selected_messages = messages;
	}
	
	var emailTblInit = function($) {
		if(SimpleMail.pageNum == 0)
		{
			$('#previous-link').addClass('link-disabled');
			$('#next-link').addClass('link-disabled');
			$('#show-all').addClass('link-disabled');
		}
		else if(SimpleMail.pageNum == 1)
		{
			$('#previous-link').addClass('link-disabled');
			$('#next-link').removeClass('link-disabled');
			$('#show-all').removeClass('link-disabled');
		}
		else if(SimpleMail.pageNum == SimpleMail.pageCount)
		{
			$('#next-link').addClass('link-disabled');
			$('#previous-link').removeClass('link-disabled');
			$('#show-all').removeClass('link-disabled');
		}
		else
		{
			$('#previous-link').removeClass('link-disabled');
			$('#next-link').removeClass('link-disabled');
			$('#show-all').removeClass('link-disabled');
		}

		$('.from-name').mouseover(function(e) {
			//var offset = $(this).offset();
			var offset = $(this).position();
				
			$('span', this).css('top', offset.top + $(this).height() );
			$('span', this).css('left', offset.left + $(this).width() - 5 );
			$('span', this).css('display', 'block' );
		});
		
		$('.email-date').mouseover(function(e) {
			//var offset = $(this).offset();
			var offset = $(this).position();
				
			$('span', this).css('top', offset.top + $(this).height() );
			$('span', this).css('left', offset.left + $(this).width() - 5 );
			$('span', this).css('display', 'block' );
		});
		
		$('.from-name').mouseout(function(e) {
			$('span', this).css('display', 'none' );
		});
		
		$('.email-date').mouseout(function(e) {
			$('span', this).css('display', 'none' );
		});
		
		$('.message_checkbox').change(function() {
			if(this.checked)
				$(this.parentNode.parentNode).addClass('row-selected');
			else
				$(this.parentNode.parentNode).removeClass('row-selected');
		});
	}
	
	var fetchEmailList = function($) {
		$('.current-page').removeClass('current-page');
		$('#page-' + SimpleMail.pageNum).parent().addClass('current-page');

		var tblHeight = $('#message_list tbody').height();
		$('#message_list tbody').html('<tr class="loading-messages" style="height:' + tblHeight +'px;"><td colspan="5"></td></tr>');

		$.get(ajaxurl, {page: SimpleMail.box, email_page: SimpleMail.pageNum, query: SimpleMail.query, criteria: SimpleMail.criteria, action: 'simplemail_get_messages'}, function(result) {
			$('#message_list tbody').html(result);
			SimpleMail.query = '';
			SimpleMail.criteria = '';
			emailTblInit($);
			messageOptionInit($);
		});
	}